                     GEM++ - C++ LIBRARIES FOR GEM/AES/VDI



NAME
     GEMalert - Alert boxes

DESCRIPTION
     Alert boxes provide a simple way of communicating simple messages
     to the user and accepting a simple response.

     By using RSC files, these alerts can still be language independent.

CONSTRUCTORS
     GEMalert(const GEMrsc& rsc, int RSCindex)
       Create a GEMalert from the given RSC index in the given GEMrsc.

     GEMalert(const char* lines, const char* buttons)
       Create a GEMalert with the given lines and buttons (separated
       by '|').  ONLY use this in cases such as when a GEMrsc cannot
       be created.

METHODS
     int Alert(int Default=-1)
       Display the alert, and return the user response - from 1 to the
       number of buttons in the Alert.

       The default button may be given as a positive number from 1 to the
       number of buttons in the Alert, OR as a -ve value indicating the
       count from right-most button.

       The default default-button is the right-most, which is probably
       the best default for right-handed users.

     int Alertf(int Default, ...)
       Substitute additional arguments into the RSC string for the alert
       in the format of printf(), then display the alert, and return the
       user response - from 1 to the number of buttons in the Alert.  The
       default button is as above.

EXAMPLES
     GEMrsc rsc("foo.rsc");
     if (!rsc) {
         GEMalert oh_dear("Cannot load file:|foo.rsc","quit|ciao");
         oh_dear.Alert(0);
     } else {
          ...
         GEMalert hello(rsc,HELLOALERT);
         hello.Alert();
     }

SEE ALSO
     GEMrsc

BUGS
     Bugs in GEM++ should be reported to warwick@cs.uq.oz.au

AUTHOR
     Warwick Allison, 1993.
     warwick@cs.uq.oz.au

COPYING
     This functionality is part of the GEM++ library,
     and is Copyright 1993 by Warwick W. Allison.

     GEM++ is free and protected under the GNU Library General Public
     License.

     You are free to copy and modify these sources, provided you
     acknowledge the origin by retaining this notice, and adhere to
     the conditions described in the GNU LGPL.
