                     GEM++ - C++ LIBRARIES FOR GEM/AES/VDI



NAME
     GEMdeskaccessory - a GEM desk accessory

DESCRIPTION
     This is the abstract base class from which a desk accessory
     derives the interactive object - defining the Open() and Close()
     methods for the desk accessory.

     NOTE: In order to use a GEMdeskaccessory, the application must use
     a statically allocated heap and stack by including the floowing
     declarations:

          char _stack_heap[8192];   // Some appropriate size
          void *_heapbase = (void *)_stack_heap;
          long _stksize = sizeof(_stack_heap);

     Also, a program may determine whether it is indeed an application
     or a desk accessory by testing the follow global value:

          extern int _app;

CONSTRUCTORS
     GEMdeskaccessory(const GEMapplication& appl,
         GEMactivity& in,
         const char* MenuItemName)
       Create a desk accessory in the given application with the given
       name in the accessory menu, that receives Open and Close events
       from the given activity.

METHODS
     virtual void Open()=0
     virtual void Close()=0
       The GEMactivity containing the GEMdeskaccessory will call these
       when the menu item for the GEMdeskaccessory is clicked, or when
       the GEMdeskaccessory must close itself (due to application change).
       Note that since GEM "automatically" deletes accessory windows,
       the accessory should merely call the BecomeDeleted() method of
       any open windows.

BUGS
     Bugs in GEM++ should be reported to warwick@cs.uq.oz.au

AUTHOR
     Warwick Allison, 1993.
     warwick@cs.uq.oz.au

COPYING
     This functionality is part of the GEM++ library,
     and is Copyright 1993 by Warwick W. Allison.

     GEM++ is free and protected under the GNU Library General Public
     License.

     You are free to copy and modify these sources, provided you
     acknowledge the origin by retaining this notice, and adhere to
     the conditions described in the GNU LGPL.
