                     GEM++ - C++ LIBRARIES FOR GEM/AES/VDI



NAME
     GEMevent

DESCRIPTION
     A GEMevent is a combination of values that represents and event.
     it also provides the functionality for collecting events from GEM.

CONSTRUCTORS
     GEMevent()
       Create an event that holds the button state in effect when
       the event is created.
     GEMevent(int x, int y, int button=0, int clicks=1)
       Creates an event that is a simulated click at the given position
       by the given button the given number of times.
     GEMevent(int key)
       Creates an event that is a simulated key press.

METHODS
     void Get(int ev_flags)
       Uses evnt_multi() to get event values - use MU_* constants
       from gemfast.h to define the types of events to accept.

     void Interval(int i)
     int Interval()
       Set/get the interval for a timer event.

     bool Keyboard()
     bool Button()
     bool Rectange1()
     bool Rectange2()
     bool Rectangle()
     bool Message()
     bool Timer()
       Test the type of event.  Note that a GEMevent may represent
       multiple events.  Normally, an event consumer will ignore these
       methods, as GEMactivity only calls consumers if the event is
       appropriate.

     int X()
     int Y()
       Mouse (x,y) position when the event occurred.

     int Message(int i)
       Return the given component of a Message event.

     int Button(int b)
       Return the state of the given button when the event occurred.

     int Clicks()
       Returns the number of mouse clicks that caused the event.

     int Meta()
       Returns the state of the metakeys (Shifts, Alt, Control, CAPS)
       when the event occurred.

     int Key()
       Returns the key of a key event (NOTE:  Do not confuse this
       with the Keyboard() predicate methods above).

     void Button(int mask, int state, bool not=FALSE)
     void Rectangle1(int x, int y, int w, int h, bool out_not_in)
     void Rectangle2(int x, int y, int w, int h, bool out_not_in)
     void Rectangle(int x, int y, int w, int h, bool out_not_in, int R=1)
       Set states of the event (for simulated events).

SEE ALSO
     GEMactivity, GEMfeedback

BUGS
     Bugs in GEM++ should be reported to warwick@cs.uq.oz.au

AUTHOR
     Warwick Allison, 1993.
     warwick@cs.uq.oz.au

COPYING
     This functionality is part of the GEM++ library,
     and is Copyright 1993 by Warwick W. Allison.

     GEM++ is free and protected under the GNU Library General Public
     License.

     You are free to copy and modify these sources, provided you
     acknowledge the origin by retaining this notice, and adhere to
     the conditions described in the GNU LGPL.
