                     GEM++ - C++ LIBRARIES FOR GEM/AES/VDI



NAME
     GEMfeedback - the result of processing a GEMevent

DESCRIPTION
     When an event occurs in a GEMactivity, it is passed to the
     appropriate object for processing.  That object then returns
     a GEMfeedback to describe its response.

     The interaction loop of a GEMform also passes events to
     component objects and reacts to their responses.

     Currently this class is just an enumeration, since the range
     of responses is minimal.

VALUES
     EndInteraction
       - Signals that the GEMactivity/GEMform should cease.
     ContinueInteraction
       - Signals that the GEMactivity/GEMform should continue.
     RedrawMe
       - Signals that the object needs to be redrawn (GEMobjects only),
         and the GEMactivity/GEMform should continue.
     RedrawMyParent
       - Signals that the parent of the object needs to be redrawn
         (GEMobjects only), and the GEMactivity/GEMform should continue.
     IgnoredClick
       - Signals that the recipient ignored the event.

SEE ALSO
     GEMactivity, GEMform,
     GEMwindow, GEMformwindow, GEMmenu, GEMobject, GEMtimer, GEMkeysink.

BUGS
     Bugs in GEM++ should be reported to warwick@cs.uq.oz.au

AUTHOR
     Warwick Allison, 1993.
     warwick@cs.uq.oz.au

COPYING
     This functionality is part of the GEM++ library,
     and is Copyright 1993 by Warwick W. Allison.

     GEM++ is free and protected under the GNU Library General Public
     License.

     You are free to copy and modify these sources, provided you
     acknowledge the origin by retaining this notice, and adhere to
     the conditions described in the GNU LGPL.
