                     GEM++ - C++ LIBRARIES FOR GEM/AES/VDI



NAME
     GEMfileselector - high-level file chooser

DESCRIPTION
     A GEMfileselector is a source of filenames.  Generally, different
     types of files (eg. Save files; Config files; Font files) should
     each have a different file selector so that the user can leave
     each fileselector in a appropriate directory.  Some types of files
     should NOT have different fileselectors... such as Save files and
     Load files!

GLOSSARY
       filename   E:\usr\gem++\foo.bar
       filespec   E:\usr\gem++\*.bar   or   *.bar
       path       E:\usr\gem++\        or   E:\usr\gem++
       file       foo.bar

     A "file" appears in the "File:" area of file selector.
     A "filespec" appears in the "Path:" area of the file selector.
     A "filename" is returns by the Get() method.

CONSTRUCTORS
     GEMfileselector(int maxlen=128);
     GEMfileselector(char* filename);

METHODS
     const char* Get(const char* prompt, char* into=0);
       Prompts user for a filename (using standard fileselector),
       returns copy of chosen filename in "into" if non-0, and returns
       a constant string.  Returns NULL if the user cancels the file
       selection.  The given prompt is used.

     AVOID using the following calls.  Each GEMfileselector should remain
     at the path the user specified.

     void Path(const char* path)
       eg. Path("E:\\foo"); Path("E:\\foo\\");

     const char* File(const char* file=0)
       eg. File("foo.bar"); oldgot=File();

     const char* Filespec(const char* filespec=0)
       eg. Filespec("*.bar"); Filespec("E:\\foo\\*.bar"); oldspec=Filespec();

     const char* Filename(const char* filename=0)
       eg. Filename("foo.bar"); Filename("E:\\foo\\foo.bar"); old=Filename();

     const char* CWD()
       Resets filespec to current work directory.

BUGS
     Bugs in GEM++ should be reported to warwick@cs.uq.oz.au

AUTHOR
     Warwick Allison, 1993.
     warwick@cs.uq.oz.au

COPYING
     This functionality is part of the GEM++ library,
     and is Copyright 1993 by Warwick W. Allison.

     GEM++ is free and protected under the GNU Library General Public
     License.

     You are free to copy and modify these sources, provided you
     acknowledge the origin by retaining this notice, and adhere to
     the conditions described in the GNU LGPL.
