                     GEM++ - C++ LIBRARIES FOR GEM/AES/VDI



NAME
     GEMhotform - GEMform with auto-select

DESCRIPTION
     A GEMhotform is a GEMform that behaves more like a menu, in that
     selectable items are selected under the mouse cursor as it moves.
     Also, clicks outside the form exit the form, returning -1 rather
     than chiming.

     This is useful for many form applications, such as pop-up menus.

CONSTRUCTORS
     GEMhotform(const GEMrsc& rsc, int RSCindex)
       As per GEMform

METHODS
     const int NoObject=-1
       Returned by FormDo() (and hence Do()) if no object is chosen in
       the form.

     virtual int DoKey(int meta, int key)
       Called when a key is pressed.  meta is the state of the shift,
       alt, control, and capslock keys, key is the scancode byte and
       the character byte of the key pressed - character in the lowest
       byte, scancode in the next-to-lowest If a value other than
       Ignore (see below) is returned, the FormDo() terminates,
       returning that value.  By default, this method returns Ignore.
       Note that normal key processing (editing, etc) is done AFTER
       this method is called, and only if it returns Ignore.

     virtual int DoOff()
       Called when the mouse is clicked outside the form.
       Default is to return NoObject.

     virtual int DoHot(int ob, bool inside)
       Called when the mouse moves into or out-of a selectable object.
       Default is to select/deselect the object.

EXTENSION
     const int Ignore=-2
       See Do*() methods above.

     virtual int FormDo()
       Overrides GEMform::FormDo(), and uses the Hot Form version of
       form_do() written by Tim Oren in the Professional GEM series.

SEE ALSO
     GEMform
     "Profession GEM" by Timothy Oren, an usenet/BBS/GEnie/etc document.

BUGS
     Bugs in GEM++ should be reported to warwick@cs.uq.oz.au

AUTHOR
     Original code by Tim Oren, made public.
     C++ conversion and exit-on-offclick by
       Warwick Allison, 1993.
       warwick@cs.uq.oz.au

COPYING
     This functionality is part of the GEM++ library,
     and is Copyright 1993 by Warwick W. Allison.

     GEM++ is free and protected under the GNU Library General Public
     License.

     You are free to copy and modify these sources, provided you
     acknowledge the origin by retaining this notice, and adhere to
     the conditions described in the GNU LGPL.
