                     GEM++ - C++ LIBRARIES FOR GEM/AES/VDI



NAME
     GEMmenu - Standard GEM menubar.

DESCRIPTION
     A GEMmenu is a standard GEM menu.  It is in a GEMactivity, and
     it receives menu selection events from that activity.  If objects
     that are selected have been declared as GEMobjects in the form, 
     the Touch() method of the object is called, otherwise the virtual
     method GEMmenu::DoItem(int) is called, which by default ends the
     interaction.

CONSTRUCTORS
     GEMmenu(GEMactivity& in, const GEMrsc& rsc, int RSCindex)
       Create a menu that reacts to events in the given activity, using
       the form specified by the given RSCindex in the given GEMrsc.

METHODS
     GEMfeedback Select(const GEMevent&)
       This method is called by the GEMactivity when menu selection
       events occur.  Note that it calls the virtual GEMform::DoItem(...)
       method.

     void Show(bool on=TRUE)
     void Hide()

EXAMPLES
     class MyMenu : public GEMmenu {
     public:
         MyMenu(GEMactivity& in, const GEMrsc& rsc) :
             GEMmenu(in,rsc,MENU_RSC_INDEX)
         { }

         virtual GEMfeedback DoItem(int item, const GEMevent& ev)
         {
             switch (item) {
              case FOO:
                 ...
             break; case FUM:
                 ...
             break; default:
                 return EndInteraction;
             }
             return ContinueInteraction;
         }
     };

     main()
     {
         GEMapplication appl;
         GEMrsc rsc("foo.rsc");
         GEMactivity act;
         MyMenu menu(act,rsc);
     }

SEE ALSO
     GEMactivity, GEMform, GEMobject

BUGS
     Bugs in GEM++ should be reported to warwick@cs.uq.oz.au

AUTHOR
     Warwick Allison, 1993.
     warwick@cs.uq.oz.au

COPYING
     This functionality is part of the GEM++ library,
     and is Copyright 1993 by Warwick W. Allison.

     GEM++ is free and protected under the GNU Library General Public
     License.

     You are free to copy and modify these sources, provided you
     acknowledge the origin by retaining this notice, and adhere to
     the conditions described in the GNU LGPL.
