                     GEM++ - C++ LIBRARIES FOR GEM/AES/VDI



NAME
     GEM++ - C++ Libraries for GEM/AES/VDI

DESCRIPTION
     The GEM++ library is a collection of C++ classes that give an
     object oriented interface to the GEM environment.

CLASS HIERARCHY
     FILE      CLASS : BASE           DESCRIPTION
     --------  ---------------------  ---------------------------------------
     gemap     GEMapplication         - One for every program.
     gemda     GEMdeskaccessory
                 : GEMapplication     - One for every desk accessory.

     gemr      GEMrsc                 - Loads and frees RSC files.
     gema      GEMactivity            - A user interaction - the main loop.
     geme      GEMevent               - A GEMactivity generates these.
     gemfb     GEMfeedback            - The result of GEMevent processing.
     gemks     GEMkeysink             - Key event consumer in a GEMactivity.
     gemt      GEMtimer               - Timer event consumer in a GEMactivity.

     gemw      GEMwindow              - Standard GEM windows.
     gemf      GEMform                - Standard GEM forms / dialog boxes.
     gemm      GEMmenu
                 : GEMform            - Standard GEM menus are forms.
     gemhf     GEMhotform
                 : GEMform            - A GEMform that with extra features.
     gemfw     GEMformwindow
                 : GEMwindow, GEMform - A GEMform in a GEMwindow.
     gemfiw    GEMformiconwindow
                 : GEMformwindow      - Iconifiable GEMformwindow.
     gemd      GEMdesktop
                 : GEMformwindow      - Standard GEM desktops are forms.

     img       IMG                    - Standard GEM image format.

     vdi       VDI                    - Standard GEM vdi calls.

     gemrawo   GEMrawobject           - GEMforms are made up of these.
     gemo      GEMobject              - Extensible layer on GEMrawobject.
     gemsl     GEMslider
                 : GEMobject          - A slider extension.
     gemto     GEMtextobject
                 : GEMobject          - A text extension.
     gemimgo   GEMimageobject
                 : GEMobject, IMG     - An extension that displays an IMG.
     gemuo     GEMuserobject
                 : GEMobject          - Extension with user defined graphics.
     gemvo     GEMvdiobject
                 : GEMuserobject      - User graphics drawn using a VDI.

     gemal     GEMalert               - Standard GEM alert boxes.
     gemfs     GEMfileselector        - Standard GEM file selector.

     gemsb     GEMstreambuf
                 : streambuf          - Interprocess communication.
     gemrec    GEMrecorder            - Records GEM events.

USAGE
     To use GEM++ with the GNU C++ compiler (G++), add the path of the
     GEM++ #include files to the GXXINC environment variable.

     Before the library can be used, it needs to be built (unless it
     is already in compiled form when you receive it).  To build the
     library, edit the makefile in the src directory to indicate your
     set-up (it should be just a matter of setting $LIBRARY and $INC),
     then type "make" in the source directory (this assumes you have
     a default.mak consistent with the one that comes with GEM++).
     If you do not use make (but you really should!), you can type:

         gcc -I../include -O2 *.cc
         gnu-ar r ../lib/gem++.olb *.o
         gnu-ar s ../lib/gem++.olb

EXAMPLES
     See the "example" directory for a program that uses GEM++.

FILES
     include/*.h      - Header files for GEM++
     src/*.cc         - C++ sources
     man/*.man        - ASCII documentation
     example/*        - Example program
     etc/default.mak  - make rules. (may need to set $MAKEFILES to this file)

SEE ALSO
     Class-specific manual entries using the filenames in the table above.

BUGS
     Bugs in GEM++ should be reported to warwick@cs.uq.oz.au

AUTHOR
     Warwick Allison, 1993.
     warwick@cs.uq.oz.au

COPYING
     This functionality is part of the GEM++ library,
     and is Copyright 1993 by Warwick W. Allison.

     GEM++ is free and protected under the GNU Library General Public
     License.

     You are free to copy and modify these sources, provided you
     acknowledge the origin by retaining this notice, and adhere to
     the conditions described in the GNU LGPL.
