                     GEM++ - C++ LIBRARIES FOR GEM/AES/VDI



NAME
     GEMrawobject - Inextensible objects in forms.

DESCRIPTION
     The standard GEM OBJECTs (defined in gemfast.h of the standard C
     library) that are used in C are a fixed structure that can be
     extended in various ways - extended types, indirect object-specific
     data, and user defined object types.

     A GEMrawobject is merely an interface to this weak object.

     See GEMobject.

CONSTRUCTORS
     GEMrawobject()
       Create an uninitialized GEMrawobject.

     GEMrawobject(const GEMrawobject&)
       Create a duplicate of a GEMrawobject.  See GEMform for details
       of the duplication convention.

METHODS
     GEMobject* Cook();
       The best thing to do with a GEMrawobject is to Cook it.
       Cook() returns 0 if no GEMobject has been declared for this object.

     SEE GEMobject for more methods.

SEE ALSO
     GEMobject, GEMform

BUGS
     Bugs in GEM++ should be reported to warwick@cs.uq.oz.au

AUTHOR
     Warwick Allison, 1993.
     warwick@cs.uq.oz.au

COPYING
     This functionality is part of the GEM++ library,
     and is Copyright 1993 by Warwick W. Allison.

     GEM++ is free and protected under the GNU Library General Public
     License.

     You are free to copy and modify these sources, provided you
     acknowledge the origin by retaining this notice, and adhere to
     the conditions described in the GNU LGPL.
