                     GEM++ - C++ LIBRARIES FOR GEM/AES/VDI



NAME
     GEMstreambuf - for interprocess communication.
     ** UNTESTED **

DESCRIPTION
     GEM allows messages to be sent between processes.  Without MultiTOS,
     this can only be between desk accessories and the main application,
     but with MultiTOS, multiple applications may communcate.

     GEMstreambuf provides a streambuf connection to another
     application.

CONSTRUCTORS
     GEMstreambuf(int ApplID)
       Create a streambuf to and from the given application.  The ApplID
       will normally be taken from a GEMapplication object.

METHODS
     virtual size_t sputn(const char* s, size_t n)
       Overrides the method in streambuf
     virtual size_t sgetn(char* s, size_t n)
       Overrides the method in streambuf

USAGE
     Create an iostream from the given buffer.

     {
         GEMapplication myself;
         GEMapplication mybuddy;
         GEMstreambuf sbuf(mybuddy);
         ostream myout(sbuf);
         istream myin(sbuf);

         myout << "Hello buddy!!"; // Protocol will usually be more complex :)
     }

SEE ALSO
     streambuf, iostream, GEMapplication

BUGS
     Bugs in GEM++ should be reported to warwick@cs.uq.oz.au

AUTHOR
     Warwick Allison, 1993.
     warwick@cs.uq.oz.au

COPYING
     This functionality is part of the GEM++ library,
     and is Copyright 1993 by Warwick W. Allison.

     GEM++ is free and protected under the GNU Library General Public
     License.

     You are free to copy and modify these sources, provided you
     acknowledge the origin by retaining this notice, and adhere to
     the conditions described in the GNU LGPL.
