                     GEM++ - C++ LIBRARIES FOR GEM/AES/VDI



NAME
     GEMvdiobject - GEMobject which draws self using VDI.

DESCRIPTION
     A GEMvdiobject is an object with a user-defined graphical
     representation, that uses a VDI to draw that representation.

     The clipping is already done for the object.

     This is an abstract base class, since Draw(x,y) is undefined.

     ********************************************************************
     NOTE: Draw(x,y) MUST NOT CALL ANY AES FUNCTIONS.  IT MAY CALL
           GEMDOS, BIOS, XBIOS, AND VDI FUNCTIONS.

           Some GEM++ methods call AES functions, most notably
           GEMobject::GetAbsoluteXY().
     ********************************************************************

CONSTRUCTORS
     GEMvdiobject(GEMform&, int RSCindex, class VDI&)
       RSCindex and GEMform as per GEMobject.  The referenced VDI
       will be used for drawing graphics.

PROTECTED MEMBER
     virtual void Draw(int x, int y)=0
       This method should draw the graphics for the object, positioned
       at (x,y) on the VDI's display.

     VDI& vdi
       The vdi to use for drawing.

SEE ALSO
     GEMellipse (in example.cc)

BUGS
     Bugs in GEM++ should be reported to warwick@cs.uq.oz.au

AUTHOR
     Warwick Allison, 1993.
     warwick@cs.uq.oz.au

COPYING
     This functionality is part of the GEM++ library,
     and is Copyright 1993 by Warwick W. Allison.

     GEM++ is free and protected under the GNU Library General Public
     License.

     You are free to copy and modify these sources, provided you
     acknowledge the origin by retaining this notice, and adhere to
     the conditions described in the GNU LGPL.
