                     GEM++ - C++ LIBRARIES FOR GEM/AES/VDI



NAME
     GRect - AES rectangle class

DESCRIPTION
     The AES often deal with rectangular areas, especially in relation
     to windows and objects.

     This class derives from the AES "GRECT" object, and is therefore
     usable in the various AES functions that require GRECTs.

CONSTRUCTORS
     GRect()
       Create a GRect with undefined dimensions.

     GRect(int x, int y, int width, int height)
       Create a GRect with the given (x,y) position and size.

METHODS
     GRect& MoveAbs(int x, int y)
       Move the GRect to the given position.  Returns self after move.
     GRect& MoveRel(int xOffset, int yOffset)
       Move the GRect by the given amounts.  Returns self after move.
     GRect& Resize(int w, int h)
       Resize the GRect to the given dimensions.  Returns self after resize.
     GRect& SetRect(int x, int y, int width, int height)
       Set the position and size of the GRect.
     
     void GetOrigin(int& x, int& y)
       Returns the (x,y) position of the GRect.

     void GetSize(int& width, int& height)
       Returns the size of the GRect.

     void GetRect(int& x, int& y, int& width, int& height)
       Returns the (x,y) position and size of the GRect.
     
     GRect& Clip(const GRect& border)
       Clip the rectangle to the given border.

     GRect& Constrain(const GRect& border)
       Move the rectangle such that it is within the given rectangle.
       The size is unchanged, so the rectangle may not fix, it which
       case, it is centred.
     
     int operator==(const GRect&)
     int operator!=(const GRect&)
       Compare rectangles.

BUGS
     Bugs in GEM++ should be reported to warwick@cs.uq.oz.au

AUTHOR
     Andre Pareis, 1992
     pareis@cs.tu-berlin.de

COPYING
     GEM++ is free and protected under the GNU Library General Public
     License.

     You are free to copy and modify these sources, provided you
     acknowledge the origin by retaining this notice, and adhere to
     the conditions described in the GNU LGPL.
