//////////////////////////////////////////////////////////////////////////////
//
//  Key scancodes.
//
//  This file is Copyright 1992,1993 by Warwick W. Allison.
//  This file is part of the gem++ library.
//  You are free to copy and modify these sources, provided you acknowledge
//  the origin by retaining this notice, and adhere to the conditions
//  described in the file COPYING.LIB.
//
//////////////////////////////////////////////////////////////////////////////

#ifndef _scancode_h
#define _scancode_h
//
//  Scancodes of all Atari keys.
//

#include <osbind.h>

inline int KeyPressed() { return Cconis(); }
inline int Key() { return Cnecin()>>16; }
inline int AsciiKey() { return Cnecin()&255; }

#define KEY_ALT
#define KEY_F1		0x3b
#define KEY_F2		0x3c
#define KEY_F3		0x3d
#define KEY_F4		0x3e
#define KEY_F5		0x3f
#define KEY_F6		0x40
#define KEY_F7		0x41
#define KEY_F8		0x42
#define KEY_F9		0x43
#define KEY_F10		0x44
#define KEY_ESC		0x01
#define KEY_1		0x02
#define KEY_2		0x03
#define KEY_3		0x04
#define KEY_4		0x05
#define KEY_5		0x06
#define KEY_6		0x07
#define KEY_7		0x08
#define KEY_8		0x09
#define KEY_9		0x0a
#define KEY_0		0x0b
#define KEY_MINUS	0x0c
#define KEY_EQUAL	0x0d
#define KEY_GRAVE	0x29
#define KEY_BS		0x0e
#define KEY_HELP	0x62
#define KEY_UNDO	0x61
#define KEY_KPOPEN	0x63
#define KEY_KPCLOSE	0x64
#define KEY_KPSLASH	0x65
#define KEY_KPSTAR	0x66
#define KEY_TAB		0x0f
#define KEY_Q		0x10
#define KEY_W		0x11
#define KEY_E		0x12
#define KEY_R		0x13
#define KEY_T		0x14
#define KEY_Y		0x15
#define KEY_U		0x16
#define KEY_I		0x17
#define KEY_O		0x18
#define KEY_P		0x19
#define KEY_OPEN	0x1a
#define KEY_CLOSE	0x1b
#define KEY_RETURN	0x1c
#define KEY_DELETE	0x53
#define KEY_INSERT	0x52
#define KEY_UP		0x48
#define KEY_HOME	0x47
#define KEY_KP7		0x67
#define KEY_KP8		0x68
#define KEY_KP9		0x69
#define KEY_KPMINUS	0x4a
#define KEY_A		0x1e
#define KEY_S		0x1f
#define KEY_D		0x20
#define KEY_F		0x21
#define KEY_G		0x22
#define KEY_H		0x23
#define KEY_J		0x24
#define KEY_K		0x25
#define KEY_L		0x26
#define KEY_SEMI	0x27
#define KEY_QUOTE	0x28
#define KEY_HASH	0x2b
#define KEY_LEFT	0x4b
#define KEY_DOWN	0x50
#define KEY_RIGHT	0x4d
#define KEY_KP4		0x6a
#define KEY_KP5		0x6b
#define KEY_KP6		0x6c
#define KEY_KPPLUS	0x4e
#define KEY_SLOSH	0x60
#define KEY_Z		0x2c
#define KEY_X		0x2d
#define KEY_C		0x2e
#define KEY_V		0x2f
#define KEY_B		0x30
#define KEY_N		0x31
#define KEY_M		0x32
#define KEY_COMMA	0x33
#define KEY_DOT		0x34
#define KEY_SLASH	0x35
#define KEY_KP1		0x6d
#define KEY_KP2		0x6e
#define KEY_KP3		0x6f
#define KEY_ENTER	0x72
#define KEY_SPACE	0x39
#define KEY_KP0		0x70
#define KEY_KPDOT	0x71

#endif
