/* This source file is part of the LynxLib miscellaneous library by
Robert Fischer, and is Copyright 1990 by Robert Fischer.  It costs no
money, and you may not make money off of it, but you may redistribute
it.  It comes with ABSOLUTELY NO WARRANTY.  See the file LYNXLIB.DOC
for more details.
To contact the author:
    Robert Fischer \\80 Killdeer Rd \\Hamden, CT   06517   USA
    (203) 288-9599     fischer-robert@cs.yale.edu                 */

#ifndef E_OSBIND_H
#include <e_osbind.h>
#endif

#define DOODLE_SIZE 9218    /* Size of a Doodle picture */
#define SCR_SIZE    32000   /* Actual # bytes in a picture */
#define NEO_SIZE    32128   /* Size of a NEO picture */
#define SPU_SIZE    51104L  /* Size of an SPU picture */
#define DEGAS_SIZE  32034   /* Size of a Degas picture */
#define PAL_SIZE    32      /* Size of pallette in bytes */
#define SPEC_PAL_SIZE   19104   /* Size of a Spectrum palette */

typedef BYTE pic_array[SCR_SIZE+256];
typedef struct {
    pic_array   p;          /* the actual array */
    char        *p_start;   /* Address of 1st data element in array */
    char        *old_phys;  /* address of old picture */
    char        *old_log;   /* Address of old logbase */
    PALETTE     pal;        /* The color palette */
    PALETTE     old_pal;    /* The old palette */
    int         rez;        /* The resolution */
    int         old_rez;    /* The resolution before picture */
} pic_rec;
typedef enum {
    DEGAS, NEO,     /* Our old DEGAS and NEO file formats */
    SPC, SPU,       /* Spectrum compressed & uncompressed */
    DOODLE,         /* Doodle, from Commodore 64 */
    PLAIN_SCREEN,   /* 32000 bytes of screen data */
#if 0
    SPLAY,          /* The splay compress format */
    COMPRESS,       /* The compress.prg (Ziv-Lempel) compress format */
#endif
    TINY,           /* A Tiny picture (another compression scheme) */
    ERROR
} pic_type;


/* Typedefs specially made for loading DOODLE pictures */
typedef BYTE COLOR_MAP[1024];   /* Commodore color table */
typedef BYTE BIT_MAP[8192];     /* Commodore bit map */
typedef struct {    /* Structure of a Doodle picture file */
    WORD load_addr; /* Basically garbage on the ST */
    COLOR_MAP c;
    BIT_MAP b;
} DOODLE_PIC;

typedef BYTE PLANE_ARRAY[160];

